using Infrastructure;
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Http;
using Microsoft.AspNetCore.Mvc;
using OpenAuth.App;
using OpenAuth.App.Response;
using OpenAuth.Repository.Domain;
using System.Threading.Tasks;

namespace OpenAuth.WebApi.Controllers.BaseControllers
{
    /// <summary>
    /// 系统配置
    /// </summary>
    [Route("api/[controller]/[action]")]
    [ApiController]
    public class SysAppSettingController : ControllerBase
    {
        private readonly SysAppSettingApp _app;
        public SysAppSettingController(SysAppSettingApp app)
        {
            _app = app;
        }

        /// <summary>
        /// 获取用户配置
        /// </summary>
        /// <param name="id"></param>
        /// <returns></returns>
        [HttpGet]
        public async Task<Response<SysAppSetting>> Get(long id)
        {
            var result = new Response<SysAppSetting>();
            try
            {
                result.Result = await _app.Get(id);
            }
            catch (Exception ex)
            {
                result.Code = 500;
                result.Message = ex.InnerException?.Message ?? ex.Message;
            }

            return result;
        }

        /// <summary>
        /// 保存用户配置
        /// </summary>
        /// <param name="obj"></param>
        /// <returns></returns>
        [HttpPost]
        public async Task<Response<bool>> Save(SysAppSetting obj)
        {
            var result = new Response<bool>();
            try
            {
                result = await _app.Save(obj);
            }
            catch (Exception ex)
            {
                result.Code = 500;
                result.Message = ex.InnerException?.Message ?? ex.Message;
            }

            return result;
        }
    }
}
